; Demonstracni aplikace pro RT jadro ve verzi 1.2Y (RTA2.ASM)
; Jadro prelozeno od 9800H
; 3 procesy

; ---------------------------------------------------------------------------

cold_start	equ	9800h

rt_create	equ	983dh
rt_kill  	equ	9894h
rt_delay	equ	98bah
rt_init_sig	equ	98d7h
rt_wait_sig	equ	9902h
rt_send_sig	equ	994ch
rt_set_slice	equ	9982h

timer0_int	equ	9985h

; ---------------------------------------------------------------------------

DSEG
		org	08h

value:		ds	1
key:		ds	1

; ---------------------------------------------------------------------------

CSEG
 		org     8000h
 		clr     EA
 		jmp     cold_start

; ---------------------------------------------------------------------------

; ULOHA 0

		org	8100h

; uloha 0 inicializuje - vytvori a spusti dalsi procesy, vytvori a 
; inicializuje signaly atd.
		
main:		lcall   disp_init
                mov	r7, #10		; telo procesu 0
		lcall	rt_set_slice	; prepinani kontextu po 10 ms

		mov	r4, #HIGH keys
		mov	r5, #LOW  keys
		mov	r7, #1
		lcall	rt_create	; vytvoreni ulohy - obsluha
					; tlacitek

		mov	r4, #HIGH led
		mov	r5, #LOW  led
		mov	r7,#2
		lcall	rt_create	; vytvoreni ulohy - blikac LED

		mov	r5, #0
		mov	r7, #0
		lcall	rt_init_sig	; inicializace signalu 0
					; = bylo stisknuto tlacitko

		mov	r5, #1
		mov	r7, #1
		lcall	rt_init_sig	; inicializace signalu 1
					; = tlacitko odebrano

		mov	value, #0	; cislo na displeji
					; pocatecni nastaveni

		mov	dpl, value	; vypiseme
		mov     dph, #0
		lcall	disp_hex

; -------

; hlavni smycka ulohy 0
; - aktualizace hodnoty citace a jeho zobrazeni na displeji

task0_loop:				; hlavni smycka ulohy 0
		mov	r7, #0
		lcall	rt_wait_sig	; pockej na stisteni tlacitka

		mov	a, key
		cjne	a, #1, not_1    ; je to TL1 ?
		inc	value           ; zvesti o 1, jestlize ano
		sjmp    free_key

not_1:		cjne	a, #2, not_2    ; je to TL2
		mov	a, value
		add	a, #10h         ; zvesti o 10h
		mov	value, a
		sjmp	free_key

not_2:		cjne	a, #3, not_3	; je to TL3
		dec	value           ; zmensi o 1
		sjmp	free_key

not_3:		cjne	a, #4, free_key ; je to TL4
		mov	a, value
		clr	c               ; zmensi o 10h
		subb	a, #10h
		mov	value, a

free_key:	mov	r7, #1       	; dej signal klavesa zpracovana
		lcall	rt_send_sig

		mov	dpl, value       ; a zobraz novou hodnotu
		mov     dph, #0
		lcall	disp_hex

		ljmp	task0_loop


; ---------------------------------------------------------------------------

; ULOHA 1 - sejmuti tlacitek

keys:   	mov	key, #0         ; inicializace

task1_loop:	mov	r7, #20		; pockame 20 ms
		lcall	rt_delay

		lcall	keyboard        ; test tlacitek
		jz	task1_loop      ; zadne - zpet
		mov	r6, a           ; pripadne tlacitko uloz do r6

		mov	r7, #1          ; pockej az uloha 0 zpracuje
		lcall	rt_wait_sig	; predchozi klavesu

		mov	key, r6       	; uloz klavesu

		mov	r7, #0      	; oznam uloze 0, ze klavesa
		lcall	rt_send_sig	; je k dispozici

key_down:	mov	r7, #20		; pockej 20 ms
		lcall	rt_delay

		lcall  	keyboard        ; je ta klavesa jeste porad stistena
		xrl	a, r6
		jz	key_down        ; pockej na pusteni

		sjmp	task1_loop      ; a znovu !


; ---------------------------------------------------------------------------

; ULOHA 2 - Blikac

led:
task2_loop:     cpl	P1.2		; zmen barvu

		mov	r7, #250        ; pockej 250 ms
		lcall	rt_delay

		cpl	P1.3		; zmen barvu

		mov	r7, #250	; pockej 250 ms
		lcall	rt_delay

		ljmp	task2_loop

; ---------------------------------------------------------------------------

; pomocna procedura volana ulohou 1

keyboard:       orl	P1, #0F0h		; precte tlacitka
		clr	P1.4
		mov	a, #1
		jnb 	P1.7, pressed
		inc	a
		jnb	P1.6, pressed
		xrl	P1, #030h
		inc	a
		jnb 	P1.7, pressed
		inc	a
		jnb	P1.6, pressed
		clr	a
pressed:	ret

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

$include (disp.asm)

		end